#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

long double prob[505][50555];

long double solve( int r, int d, int t, int s, double p ) {
	long double ans = 0.0;
	for (int i = 0; i <= s; ++i) {
		for( int j = 0; j <= r + (s - 1) * (d - t); ++j) {
			prob[i][j] = 0.0;
		}
	}
	prob[0][r] = 1.0;
    for (int i = 1; i <= s; ++i) {
        for (int j = 1; j <= r + (i - 1) * (d - t); ++j) {
            if (j - t > (s - i) * t) { // Gandalf anyway alive
                ans += prob[i - 1][j];
            } else if (j - t > 0) { // Gandalf still alive
                prob[i][j - t] += prob[i - 1][j] * (1.0 - p); // staff doesn't work
                prob[i][j - t + d] += prob[i - 1][j] * p; // staff works
            }
        }
    }

    for (int j = 1; j <= r + (s - 1) * (d - t); ++j) {
        ans += prob[s][j];
    }
    return ans;
}

int main( int argc, char *argv[] ) {
	registerGen(argc, argv, 1);
	cin.tie(0); cin.sync_with_stdio(0);

	int min_d = atoi(argv[1]);
	int max_d = atoi(argv[2]);
	int min_t = atoi(argv[3]);
	int max_t = atoi(argv[4]);

	int min_s = atoi(argv[5]);
	int max_s = atoi(argv[6]);

	double min_p = atof(argv[7]);
	double max_p = atof(argv[8]);

	double min_ans = 0.3;
	double max_ans = 0.7;

	int d = rnd.next(min_d, max_d);
	int t = rnd.next(min_t, max_t);

	int s = rnd.next(min_s, max_s);
	double p = rnd.next(min_p, max_p);
	double ans = rnd.next(min_ans, max_ans);

	int min_r = 1;
	int max_r = 50000;
	while( min_r != max_r ) {
		int r = ( min_r + max_r ) / 2;
		double res = solve( r, d, t, s, p );
		if( res > ans )
			max_r = r;
		else
			min_r = r + 1;
	}
	int r = max_r;

	cout << r << " " << d << " " << t << " " << s << endl;
	cout << fixed << setprecision( 5 ) << p << endl;
    return 0;
}
